



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 4858 分块</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 4858 分块</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 21:52:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：http://acm.hdu.edu.cn/showproblem.php?pid=4858</p>
<p>题意：中文题面</p>
<p>思路：来自此<a href="http://www.cnblogs.com/fenice/p/5553105.html" rel="external nofollow noreferrer">博客</a></p>
<p>对每个点定义两个值：val，sum，val记录自己的特征值，sum记录周边所有点特征值的和。</p>
<p>现在我们把所有的节点分成两类，重点(度数&gt;=sqrt(m))，轻点(度数sqrt(m))。</p>
<p>插入：</p>
<p>轻点更新自己的val，同时更新所有的邻点的sum值</p>
<p>重点更新自己的val,同时只更新相邻重点的sum值（所以重点不需要连边到轻点）</p>
<p>查询：</p>
<p>轻点：暴力周边的所有邻点的val值。</p>
<p>重点：直接输出自己的sum值。</p>
<p>性质：</p>
<p>与重点相邻的重点不超过sqrt(m)个。</p>
<p>与轻点相邻的所有点不超过sqrt(m)个。</p>
<div>
<pre class="prettyprint linenums">#define _CRT_SECURE_NO_DEPRECATE<br />
#include&lt;stdio.h&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;math.h&gt;<br />
#include&lt;time.h&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;iostream&gt;<br />
using namespace std;<br />
typedef long long int LL;<br />
const int MAXN =  + ;<br />
struct Edges{<br />
    int u, v; Edges(int u = , int v = ) :u(u), v(v){};<br />
};<br />
vector&lt;Edges&gt;edge;<br />
vector&lt;int&gt;G[MAXN];<br />
int val[MAXN],du[MAXN];<br />
LL sum[MAXN];<br />
int main(){<br />
//#ifdef kirito<br />
//    freopen("in.txt", "r", stdin);<br />
//    freopen("out.txt", "w", stdout);<br />
//#endif<br />
//    int start = clock();<br />
    int t, n, m, q;<br />
    scanf("%d", &amp;t);<br />
    while (t--){<br />
        scanf("%d%d", &amp;n, &amp;m); edge.clear();  int block = (int)sqrt(m + 0.5);<br />
        for (int i = ; i &lt;= n; i++){<br />
            G[i].clear(); val[i] = ; du[i] = ; sum[i] = ;<br />
        }<br />
        for (int i = ; i &lt;= m; i++){<br />
            int u, v; scanf("%d%d", &amp;u, &amp;v);<br />
            edge.push_back(Edges(u, v));<br />
            du[u]++; du[v]++;<br />
        }<br />
        for (int i = ; i &lt; edge.size(); i++){<br />
            int u = edge[i].u, v = edge[i].v;<br />
            if (du[u] &gt;= block&amp;&amp;du[v]&gt;=block){<br />
                G[u].push_back(v); G[v].push_back(u);<br />
            }<br />
            if (du[u] &lt; block){<br />
                G[u].push_back(v);<br />
            }<br />
            if (du[v] &lt; block){<br />
                G[v].push_back(u);<br />
            }<br />
        }<br />
        scanf("%d", &amp;q);<br />
        while (q--){<br />
            int type, pos, v; scanf("%d", &amp;type);<br />
            if (type){<br />
                LL cnt = ; scanf("%d", &amp;pos);<br />
                if (du[pos] &lt; block){<br />
                    for (int i = ; i &lt; G[pos].size(); i++){<br />
                        cnt += val[G[pos][i]];<br />
                    }<br />
                }<br />
                else{<br />
                    cnt = sum[pos];<br />
                }<br />
                printf("%I64d\n", cnt);<br />
            }<br />
            else{<br />
                scanf("%d %d", &amp;pos, &amp;v);<br />
                val[pos] += v;<br />
                for (int i = ; i &lt; G[pos].size(); i++){ sum[G[pos][i]] += v; }<br />
            }<br />
        }

    }<br />
//#ifdef LOCAL_TIME<br />
//    cout &lt;&lt; "[Finished in " &lt;&lt; clock() - start &lt;&lt; " ms]" &lt;&lt; endl;<br />
//#endif<br />
    return ;<br />
}</pre>
</div>
<p>思路2：另一种方法。 可能由于数据弱，所以本题可以完全按照题意暴力。 不过暴力的复杂度是O(n^2)的。只是本题没卡该做法。</p>
<div>
<pre class="prettyprint linenums">#define _CRT_SECURE_NO_DEPRECATE<br />
#include&lt;stdio.h&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;math.h&gt;<br />
#include&lt;time.h&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;iostream&gt;<br />
using namespace std;<br />
typedef long long int LL;<br />
const int MAXN =  + ;<br />
vector&lt;int&gt;G[MAXN];<br />
int val[MAXN];<br />
int main(){<br />
//#ifdef kirito<br />
//    freopen("in.txt", "r", stdin);<br />
//    freopen("out.txt", "w", stdout);<br />
//#endif<br />
//    int start = clock();<br />
    int t, n, m, q;<br />
    scanf("%d", &amp;t);<br />
    while (t--){<br />
        scanf("%d%d", &amp;n, &amp;m);<br />
        for (int i = ; i &lt;= n; i++){<br />
            G[i].clear(); val[i] = ;<br />
        }<br />
        for (int i = ; i &lt;= m; i++){<br />
            int u, v; scanf("%d%d", &amp;u, &amp;v);<br />
            G[u].push_back(v); G[v].push_back(u);<br />
        }<br />
        scanf("%d", &amp;q);<br />
        for (int i = ; i &lt;= q; i++){<br />
            int type, pos, v;<br />
            scanf("%d", &amp;type);<br />
            if (type){<br />
                LL cnt = ; scanf("%d", &amp;pos);<br />
                for (int k = ; k &lt; G[pos].size(); k++){<br />
                    cnt += val[G[pos][k]];<br />
                }<br />
                printf("%I64d\n", cnt);<br />
            }<br />
            else{<br />
                scanf("%d %d", &amp;pos, &amp;v);<br />
                val[pos] += v;<br />
            }<br />
        }

    }<br />
//#ifdef LOCAL_TIME<br />
//    cout &lt;&lt; "[Finished in " &lt;&lt; clock() - start &lt;&lt; " ms]" &lt;&lt; endl;<br />
//#endif<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8oxe58z.html">sencha ext js 6 入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qydz6mq.html">差分进化算法 DE-Differential Evolution</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77ojkq.html">css3 动画效果 定义和绑定执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mx3r09.html">&amp;quot&semi;Timeout&amp;quot&semi;在测试框架里是如何被实现的</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jg54e9.html">javascript字符串截取的substring、substr和slice</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m63j69.html">【BZOJ】2237&colon; &lbrack;NCPC2009&rsqb;Flight Planning</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gv5ke9.html">斯诺登称NSA攻破互联网加密技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnnl79.html">PostgreSQL9&period;2&period;4内核源码结构介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3kvx9.html">poj2388解题报告（排序）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydedydq.html">低功耗之战！ANT VS Bluetooth LE</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgz1548.html">安装andriod studio时出现Internal error&period; Please report to https&colon;&sol;&sol;code&period;google&period;com&sol;p&sol;an</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7k7o8.html">Linux下which、whereis、locate、find 区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11m0oq.html">java通过抛异常来返回提示信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdog6z9.html">luogu P3238 &lbrack;HNOI2014&rsqb;道路堵塞</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2k51j9.html">CentOS安装和配置Nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv421z8.html">Android之ListView，AsyncTask，GridView，CardView，本地数据存储，SQLite数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r32648.html">Educational Codeforces Round 54 ---1076ABCDE</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl0k4y9.html">laravel command</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7yleq.html">Uploadify火狐出现302错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7v6eq.html">django 错误之  OSError&colon; mysql&lowbar;config not found</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495pr4vq.html">usr&sol;include&sol;dispatch - dispatch&lowbar;source</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvdvoyq.html">PHP WAMP 文件上传 及 简单的上传预览</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvd1kjq.html">搭建FTP服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qndjr38.html">&lbrack;Unity3d&rsqb;调试问题之UI&sol;Image不显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd5wlz9.html">JSONP 理解 和 实例 讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwolrz9.html">&lbrack;UML&rsqb;UML系列&mdash;&mdash;类图class的实现关系Realization</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mdj5r8.html">媒体查询判断ipad和iPhone各版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd5dnx9.html">编译器 cc、gcc、g&plus;&plus;、CC 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96md3n8.html">VS2013编译Qt5&period;6&period;0静态库</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pmged9.html">FileZillaFTP使用教程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
